#include "wgl.h"
#include "wglext.h"

PFNGLACTIVETEXTUREPROC                  glActiveTexture             ;
PFNGLATTACHSHADERPROC                   glAttachShader              ;
PFNGLBEGINTRANSFORMFEEDBACKPROC         glBeginTransformFeedback    ;
PFNGLBINDATTRIBLOCATIONPROC             glBindAttribLocation        ;
PFNGLBINDBUFFERBASEPROC                 glBindBufferBase            ;
PFNGLBINDBUFFERPROC                     glBindBuffer                ;
PFNGLBINDFRAMEBUFFERPROC                glBindFramebuffer           ;
PFNGLBINDRENDERBUFFERPROC               glBindRenderBuffer          ;
PFNGLBINDVERTEXARRAYPROC                glBindVertexArray           ;
PFNGLBLITFRAMEBUFFERPROC                glBlitFramebuffer           ;
PFNGLBUFFERDATAPROC                     glBufferData                ;
PFNGLCHECKFRAMEBUFFERSTATUSPROC         glCheckFramebufferStatus    ;
PFNGLCOMPILESHADERPROC                  glCompileShader             ;
PFNGLCREATEPROGRAMPROC                  glCreateProgram             ;
PFNGLCREATESHADERPROC                   glCreateShader              ;
PFNGLDELETEBUFFERSPROC                  glDeleteBuffers             ;
PFNGLDELETEPROGRAMPROC                  glDeleteProgram             ;
PFNGLDELETESHADERPROC                   glDeleteShader              ;
PFNGLDISABLEVERTEXATTRIBARRAYPROC       glDisableVertexAttribArray  ;
PFNGLDRAWBUFFERSPROC                    glDrawBuffers               ;
PFNGLENABLEVERTEXATTRIBARRAYPROC        glEnableVertexAttribArray   ;
PFNGLENDTRANSFORMFEEDBACKPROC           glEndTransformFeedback      ;
PFNGLFRAMEBUFFERRENDERBUFFERPROC        glFramebufferRenderbuffer   ;
PFNGLFRAMEBUFFERTEXTURE2DPROC           glFramebufferTexture2D      ;
PFNGLFRAMEBUFFERTEXTUREPROC             glFramebufferTexture        ;
PFNGLGENBUFFERSPROC                     glGenBuffers                ;
PFNGLGENERATEMIPMAPPROC                 glGenerateMipmap            ;
PFNGLGENFRAMEBUFFERSPROC                glGenFramebuffers           ;
PFNGLGENRENDERBUFFERSPROC               glGenRenderBuffers          ;
PFNGLGENVERTEXARRAYSPROC                glGenVertexArrays           ;
PFNGLGETATTRIBLOCATIONPROC              glGetAttribLocation         ;
PFNGLGETBUFFERSUBDATAPROC               glGetBufferSubData          ;
PFNGLGETPROGRAMINFOLOGPROC              glGetProgramInfoLog         ;
PFNGLGETSHADERINFOLOGPROC               glGetShaderInfoLog          ;
PFNGLGETUNIFORMLOCATIONPROC             glGetUniformLocation        ;
PFNGLLINKPROGRAMPROC                    glLinkProgram               ;
PFNGLMAPBUFFERPROC                      glMapBuffer                 ;
PFNGLPROGRAMUNIFORM1IPROC               glProgramUniform1i          ;
PFNGLRENDERBUFFERSTORAGEMULTISAMPLEPROC glRenderbufferStorageMultisample;
PFNGLRENDERBUFFERSTORAGEPROC            glRenderBufferStorage       ;
PFNGLSHADERSOURCEPROC                   glShaderSource              ;
PFNGLTEXIMAGE2DMULTISAMPLEPROC          glTexImage2DMultisample     ;
PFNGLTEXIMAGE3DPROC                     glTexImage3D                ;
PFNGLTRANSFORMFEEDBACKVARYINGSPROC      glTransformFeedbackVaryings ;
PFNGLUNIFORM1FPROC                      glUniform1f                 ;
PFNGLUNIFORM1IPROC                      glUniform1i                 ;
PFNGLUNIFORM4FVPROC                     glUniform4fv                ;
PFNGLUNIFORMMATRIX4FVPROC               glUniformMatrix4fv          ;
PFNGLUNMAPBUFFERPROC                    glUnmapBuffer               ;
PFNGLUSEPROGRAMPROC                     glUseProgram                ;
PFNGLVERTEXATTRIBPOINTERPROC            glVertexAttribPointer       ;
PFNGLGENQUERIESPROC                     glGenQueries                ;
PFNGLDELETEQUERIESPROC                  glDeleteQueries             ;
PFNGLGETQUERYOBJECTUIVPROC              glGetQueryObjectuiv         ;
PFNGLBEGINQUERYPROC                     glBeginQuery                ;
PFNGLENDQUERYPROC                       glEndQuery                  ;
PFNGLGETSHADERIVPROC                    glGetShaderiv               ;
PFNGLGETPROGRAMIVPROC                   glGetProgramiv              ;

void wgl_init(wgl_ctx &ctx) {
	ctx.hdc = GetDC(ctx.hWnd);
	static const PIXELFORMATDESCRIPTOR pfd = {
		sizeof(PIXELFORMATDESCRIPTOR),                                 // WORD  nSize;
		1,                                                             // WORD  nVersion;
		PFD_DOUBLEBUFFER | PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL,    // DWORD dwFlags;
		PFD_TYPE_RGBA,                                                 // BYTE  iPixelType;
		32,                                                            // BYTE  cColorBits;
		0,                                                             // BYTE  cRedBits;
		0,                                                             // BYTE  cRedShift;
		0,                                                             // BYTE  cGreenBits;
		0,                                                             // BYTE  cGreenShift;
		0,                                                             // BYTE  cBlueBits;
		0,                                                             // BYTE  cBlueShift;
		8,                                                             // BYTE  cAlphaBits;
		0,                                                             // BYTE  cAlphaShift;
		0,                                                             // BYTE  cAccumBits;
		0,                                                             // BYTE  cAccumRedBits;
		0,                                                             // BYTE  cAccumGreenBits;
		0,                                                             // BYTE  cAccumBlueBits;
		0,                                                             // BYTE  cAccumAlphaBits;
		16                                                             // BYTE  cDepthBits;
	};
	SetPixelFormat(ctx.hdc, ChoosePixelFormat(ctx.hdc, &pfd), &pfd);
	ctx.hrc = wglCreateContext(ctx.hdc);
	wglMakeCurrent(ctx.hdc, ctx.hrc);

	if(0) {
		PFNWGLCREATECONTEXTATTRIBSARBPROC wglCreateContextAttribsARB= (PFNWGLCREATECONTEXTATTRIBSARBPROC)wglGetProcAddress( "wglCreateContextAttribsARB" );
		static const int  att[] = {
			WGL_CONTEXT_MAJOR_VERSION_ARB,   4,
			WGL_CONTEXT_MINOR_VERSION_ARB,   5,
			WGL_CONTEXT_FLAGS_ARB,           0,
			WGL_CONTEXT_PROFILE_MASK_ARB,
			WGL_CONTEXT_CORE_PROFILE_BIT_ARB,
			0,
		};

		HGLRC hrc = wglCreateContextAttribsARB(ctx.hdc, NULL, att );
		wglMakeCurrent(ctx.hdc, hrc );
		wglDeleteContext( ctx.hrc );
		ctx.hrc = hrc;
	}

	glActiveTexture                  = (PFNGLACTIVETEXTUREPROC             )wglGetProcAddress("glActiveTexture");
	glAttachShader                   = (PFNGLATTACHSHADERPROC              )wglGetProcAddress("glAttachShader");
	glBeginTransformFeedback         = (PFNGLBEGINTRANSFORMFEEDBACKPROC    )wglGetProcAddress("glBeginTransformFeedback");
	glBindAttribLocation             = (PFNGLBINDATTRIBLOCATIONPROC        )wglGetProcAddress("glBindAttribLocation");
	glBindBuffer                     = (PFNGLBINDBUFFERPROC                )wglGetProcAddress("glBindBuffer");
	glBindBufferBase                 = (PFNGLBINDBUFFERBASEPROC            )wglGetProcAddress("glBindBufferBase");
	glBindFramebuffer                = (PFNGLBINDFRAMEBUFFERPROC           )wglGetProcAddress("glBindFramebuffer");
	glBindRenderBuffer               = (PFNGLBINDRENDERBUFFERPROC          )wglGetProcAddress("glBindRenderbuffer");
	glBindVertexArray                = (PFNGLBINDVERTEXARRAYPROC           )wglGetProcAddress("glBindVertexArray");
	glBlitFramebuffer                = (PFNGLBLITFRAMEBUFFERPROC           )wglGetProcAddress("glBlitFramebuffer");
	glBufferData                     = (PFNGLBUFFERDATAPROC                )wglGetProcAddress("glBufferData");
	glCheckFramebufferStatus         = (PFNGLCHECKFRAMEBUFFERSTATUSPROC    )wglGetProcAddress("glCheckFramebufferStatus");
	glCompileShader                  = (PFNGLCOMPILESHADERPROC             )wglGetProcAddress("glCompileShader");
	glCreateProgram                  = (PFNGLCREATEPROGRAMPROC             )wglGetProcAddress("glCreateProgram");
	glCreateShader                   = (PFNGLCREATESHADERPROC              )wglGetProcAddress("glCreateShader");
	glDeleteBuffers                  = (PFNGLDELETEBUFFERSPROC             )wglGetProcAddress("glDeleteBuffers");
	glDeleteProgram                  = (PFNGLDELETEPROGRAMPROC             )wglGetProcAddress("glDeleteProgram");
	glDeleteShader                   = (PFNGLDELETESHADERPROC              )wglGetProcAddress("glDeleteShader");
	glDisableVertexAttribArray       = (PFNGLDISABLEVERTEXATTRIBARRAYPROC  )wglGetProcAddress("glDisableVertexAttribArray");;
	glDrawBuffers                    = (PFNGLDRAWBUFFERSPROC               )wglGetProcAddress("glDrawBuffers");
	glDrawBuffers                    = (PFNGLDRAWBUFFERSPROC               )wglGetProcAddress("glDrawBuffers");
	glEnableVertexAttribArray        = (PFNGLENABLEVERTEXATTRIBARRAYPROC   )wglGetProcAddress("glEnableVertexAttribArray");
	glEndTransformFeedback           = (PFNGLENDTRANSFORMFEEDBACKPROC      )wglGetProcAddress("glEndTransformFeedback");
	glFramebufferRenderbuffer        = (PFNGLFRAMEBUFFERRENDERBUFFERPROC   )wglGetProcAddress("glFramebufferRenderbuffer");
	glFramebufferTexture             = (PFNGLFRAMEBUFFERTEXTUREPROC        )wglGetProcAddress("glFramebufferTexture");
	glFramebufferTexture2D           = (PFNGLFRAMEBUFFERTEXTURE2DPROC      )wglGetProcAddress("glFramebufferTexture2D");
	glGenBuffers                     = (PFNGLGENBUFFERSPROC                )wglGetProcAddress("glGenBuffers");
	glGenFramebuffers                = (PFNGLGENFRAMEBUFFERSPROC           )wglGetProcAddress("glGenFramebuffers");
	glGenRenderBuffers               = (PFNGLGENRENDERBUFFERSPROC          )wglGetProcAddress("glGenRenderbuffers");
	glGenVertexArrays                = (PFNGLGENVERTEXARRAYSPROC           )wglGetProcAddress("glGenVertexArrays");
	glGenerateMipmap                 = (PFNGLGENERATEMIPMAPPROC            )wglGetProcAddress("glGenerateMipmap");
	glGetAttribLocation              = (PFNGLGETATTRIBLOCATIONPROC         )wglGetProcAddress("glGetAttribLocation");
	glGetBufferSubData               = (PFNGLGETBUFFERSUBDATAPROC          )wglGetProcAddress("glGetBufferSubData");
	glGetProgramInfoLog              = (PFNGLGETPROGRAMINFOLOGPROC         )wglGetProcAddress("glGetProgramInfoLog");
	glGetShaderInfoLog               = (PFNGLGETSHADERINFOLOGPROC          )wglGetProcAddress("glGetShaderInfoLog");
	glGetUniformLocation             = (PFNGLGETUNIFORMLOCATIONPROC        )wglGetProcAddress("glGetUniformLocation");
	glLinkProgram                    = (PFNGLLINKPROGRAMPROC               )wglGetProcAddress("glLinkProgram");
	glMapBuffer                      = (PFNGLMAPBUFFERPROC                 )wglGetProcAddress("glMapBuffer");
	glProgramUniform1i               = (PFNGLPROGRAMUNIFORM1IPROC          )wglGetProcAddress("glProgramUniform1i");
	glRenderBufferStorage            = (PFNGLRENDERBUFFERSTORAGEPROC       )wglGetProcAddress("glRenderbufferStorage");
	glRenderbufferStorageMultisample = (PFNGLRENDERBUFFERSTORAGEMULTISAMPLEPROC)wglGetProcAddress("glRenderbufferStorageMultisample");
	glShaderSource                   = (PFNGLSHADERSOURCEPROC              )wglGetProcAddress("glShaderSource");
	glTexImage2DMultisample          = (PFNGLTEXIMAGE2DMULTISAMPLEPROC     )wglGetProcAddress("glTexImage2DMultisample");
	glTexImage3D                     = (PFNGLTEXIMAGE3DPROC                )wglGetProcAddress("glTexImage3D");
	glTransformFeedbackVaryings      = (PFNGLTRANSFORMFEEDBACKVARYINGSPROC )wglGetProcAddress("glTransformFeedbackVaryings");
	glUniform1f                      = (PFNGLUNIFORM1FPROC                 )wglGetProcAddress("glUniform1f");
	glUniform1i                      = (PFNGLUNIFORM1IPROC                 )wglGetProcAddress("glUniform1i");
	glUniform4fv                     = (PFNGLUNIFORM4FVPROC                )wglGetProcAddress("glUniform4fv");
	glUniformMatrix4fv               = (PFNGLUNIFORMMATRIX4FVPROC          )wglGetProcAddress("glUniformMatrix4fv");
	glUnmapBuffer                    = (PFNGLUNMAPBUFFERPROC               )wglGetProcAddress("glUnmapBuffer");
	glUseProgram                     = (PFNGLUSEPROGRAMPROC                )wglGetProcAddress("glUseProgram");
	glVertexAttribPointer            = (PFNGLVERTEXATTRIBPOINTERPROC       )wglGetProcAddress("glVertexAttribPointer");
	glGenQueries                     = (PFNGLGENQUERIESPROC                )wglGetProcAddress("glGenQueries");
	glDeleteQueries                  = (PFNGLDELETEQUERIESPROC             )wglGetProcAddress("glDeleteQueries");
	glGetQueryObjectuiv              = (PFNGLGETQUERYOBJECTUIVPROC         )wglGetProcAddress("glGetQueryObjectuiv");
	glBeginQuery                     = (PFNGLBEGINQUERYPROC                )wglGetProcAddress("glBeginQuery");
	glEndQuery                       = (PFNGLENDQUERYPROC                  )wglGetProcAddress("glEndQuery");
	glGetShaderiv                    = (PFNGLGETSHADERIVPROC               )wglGetProcAddress("glGetShaderiv");
	glGetProgramiv                   = (PFNGLGETPROGRAMIVPROC              )wglGetProcAddress("glGetProgramiv");

	//MessageBox(0, (char *)glGetString(GL_VERSION), "OPENGL VERSION",0);
}

void wgl_term(wgl_ctx &ctx) {
	if(ctx.hrc) wglDeleteContext(ctx.hrc);
}

void wgl_swap_buffer(wgl_ctx &ctx) {
	wglSwapLayerBuffers(ctx.hdc, WGL_SWAP_MAIN_PLANE);
}

