#ifndef _WGL_H_
#define _WGL_H_

#include <windows.h>

#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glext.h>

struct wgl_ctx {
	HWND hWnd;
	HDC hdc;
	HGLRC hrc;
};

extern PFNGLACTIVETEXTUREPROC                  glActiveTexture             ;
extern PFNGLATTACHSHADERPROC                   glAttachShader              ;
extern PFNGLBEGINTRANSFORMFEEDBACKPROC         glBeginTransformFeedback    ;
extern PFNGLBINDATTRIBLOCATIONPROC             glBindAttribLocation        ;
extern PFNGLBINDBUFFERBASEPROC                 glBindBufferBase            ;
extern PFNGLBINDBUFFERPROC                     glBindBuffer                ;
extern PFNGLBINDFRAMEBUFFERPROC                glBindFramebuffer           ;
extern PFNGLBINDRENDERBUFFERPROC               glBindRenderBuffer          ;
extern PFNGLBINDVERTEXARRAYPROC                glBindVertexArray           ;
extern PFNGLBLITFRAMEBUFFERPROC                glBlitFramebuffer           ;
extern PFNGLBUFFERDATAPROC                     glBufferData                ;
extern PFNGLCHECKFRAMEBUFFERSTATUSPROC         glCheckFramebufferStatus    ;
extern PFNGLCOMPILESHADERPROC                  glCompileShader             ;
extern PFNGLCREATEPROGRAMPROC                  glCreateProgram             ;
extern PFNGLCREATESHADERPROC                   glCreateShader              ;
extern PFNGLDELETEBUFFERSPROC                  glDeleteBuffers             ;
extern PFNGLDELETEPROGRAMPROC                  glDeleteProgram             ;
extern PFNGLDELETESHADERPROC                   glDeleteShader              ;
extern PFNGLDISABLEVERTEXATTRIBARRAYPROC       glDisableVertexAttribArray  ;
extern PFNGLDRAWBUFFERSPROC                    glDrawBuffers               ;
extern PFNGLENABLEVERTEXATTRIBARRAYPROC        glEnableVertexAttribArray   ;
extern PFNGLENDTRANSFORMFEEDBACKPROC           glEndTransformFeedback      ;
extern PFNGLFRAMEBUFFERRENDERBUFFERPROC        glFramebufferRenderbuffer   ;
extern PFNGLFRAMEBUFFERTEXTURE2DPROC           glFramebufferTexture2D      ;
extern PFNGLFRAMEBUFFERTEXTUREPROC             glFramebufferTexture        ;
extern PFNGLGENBUFFERSPROC                     glGenBuffers                ;
extern PFNGLGENERATEMIPMAPPROC                 glGenerateMipmap            ;
extern PFNGLGENFRAMEBUFFERSPROC                glGenFramebuffers           ;
extern PFNGLGENRENDERBUFFERSPROC               glGenRenderBuffers          ;
extern PFNGLGENVERTEXARRAYSPROC                glGenVertexArrays           ;
extern PFNGLGETATTRIBLOCATIONPROC              glGetAttribLocation         ;
extern PFNGLGETBUFFERSUBDATAPROC               glGetBufferSubData          ;
extern PFNGLGETPROGRAMINFOLOGPROC              glGetProgramInfoLog         ;
extern PFNGLGETSHADERINFOLOGPROC               glGetShaderInfoLog          ;
extern PFNGLGETUNIFORMLOCATIONPROC             glGetUniformLocation        ;
extern PFNGLLINKPROGRAMPROC                    glLinkProgram               ;
extern PFNGLMAPBUFFERPROC                      glMapBuffer                 ;
extern PFNGLPROGRAMUNIFORM1IPROC               glProgramUniform1i          ;
extern PFNGLRENDERBUFFERSTORAGEMULTISAMPLEPROC glRenderbufferStorageMultisample;
extern PFNGLRENDERBUFFERSTORAGEPROC            glRenderBufferStorage       ;
extern PFNGLSHADERSOURCEPROC                   glShaderSource              ;
extern PFNGLTEXIMAGE2DMULTISAMPLEPROC          glTexImage2DMultisample     ;
extern PFNGLTEXIMAGE3DPROC                     glTexImage3D                ;
extern PFNGLTRANSFORMFEEDBACKVARYINGSPROC      glTransformFeedbackVaryings ;
extern PFNGLUNIFORM1FPROC                      glUniform1f                 ;
extern PFNGLUNIFORM1IPROC                      glUniform1i                 ;
extern PFNGLUNIFORM4FVPROC                     glUniform4fv                ;
extern PFNGLUNIFORMMATRIX4FVPROC               glUniformMatrix4fv          ;
extern PFNGLUNMAPBUFFERPROC                    glUnmapBuffer               ;
extern PFNGLUSEPROGRAMPROC                     glUseProgram                ;
extern PFNGLVERTEXATTRIBPOINTERPROC            glVertexAttribPointer       ;
extern PFNGLGENQUERIESPROC                     glGenQueries                ;
extern PFNGLDELETEQUERIESPROC                  glDeleteQueries             ;
extern PFNGLGETQUERYOBJECTUIVPROC              glGetQueryObjectuiv         ;
extern PFNGLBEGINQUERYPROC                     glBeginQuery                ;
extern PFNGLENDQUERYPROC                       glEndQuery                  ;
extern PFNGLGETSHADERIVPROC                    glGetShaderiv               ;
extern PFNGLGETPROGRAMIVPROC                   glGetProgramiv              ;


void wgl_init(wgl_ctx &ctx);
void wgl_term(wgl_ctx &ctx);
void wgl_swap_buffer(wgl_ctx &ctx);

#endif
